#include <stdio.h>
#include <stdlib.h>

#include "cra_ex.h"

void craex_hit(struct craex_lib libex, int num
	       , char *message , struct craex_data *data)
{
  fflush(stdout);
  if (! libex.exceptions[num].jmp && ! libex.exceptions[num].call) {
    fprintf(stderr,
	    "Unhandled exception '%s' in Library '%s'\n"
	    "Message was '%s'\n"
	    ,libex.texte[num]
	    ,libex.libname
	    ,message
	    );
    if (!getenv("CRAEX_DONTCORE")) {
      fprintf(stderr,"Aborting - dumping core\n");
      abort();
    }
    else {
      exit(41);
    }
  }
  if (libex.exceptions[num].call) {
    /* FIXME */
    fprintf(stderr,"Warning, cra_ex doesn't handle function invocation yet\n");
  }
  if (libex.exceptions[num].jmp) {
    longjmp(*(libex.exceptions[num].jmp),41);
  }
  fprintf(stderr,"Ein Handler ohne handling\n");
  abort();
}
