#include <setjmp.h>

struct craex_data {
  void *data;
};

typedef int(craex_call)(struct craex_data *data);


struct craex_ex {
  jmp_buf *jmp;
  craex_call *call;
};

struct craex_lib {
  struct craex_ex *exceptions;
  int n_exceptions;
  const char *const *const texte;
  const char *const libname;
};

void craex_hit(struct craex_lib exceptions, int num
	       , char *message , struct craex_data *data)
#ifdef __GNUC__
     __attribute__ ((noreturn))
#endif
;

#define CRAEX_SET(__lib__,__ex__) { \
  jmp_buf **__exloc__; \
  jmp_buf *__oldex__; \
  jmp_buf __newex__; \
  __exloc__ = &(__lib__ ## _ex.exceptions[__lib__ ## _ ## __ex__].jmp); \
  __oldex__ = __lib__ ## _ex.exceptions[ __lib__ ## _ ## __ex__].jmp; \
  __lib__ ## _ex.exceptions[ __lib__ ## _ ## __ex__].jmp = &__newex__; \
  if (!setjmp(__newex__)) {


#define CRAEX_HANDLE } else

#define CRAEX_END \
  *__exloc__ = __oldex__; \
  } \



