#include <stdio.h>
#include <stdlib.h>

#include <cra_ex.h>

#include <testlib1.h>
#include <testlib2.h>

/*
  lib1_ex.exceptions[lib1_is5].jmp = &(lib1_exjmp[lib1_is5]);
  if (!(retval = setjmp(*(lib1_ex.exceptions[lib1_is5].jmp)))) {
  */

int main(int argc, char *argv[]) 
{
  int i,j;
  
  printf("Normal durchlaufen, exception is5 fangen\n");
  CRAEX_SET(lib1,is5) {
    for (i = 1 ; i <=6 ; i++) {
      for (j = 1 ; j <=6 ; j++) {
	printf("Ret: %d + %d = %d\n",i,j,lib1_driver(i,j));
      }
    }
  }
  CRAEX_HANDLE {
    printf("Exception is5 gefangen\n");
  }
  CRAEX_END;
  
  printf("\nSehen, ob drunterliegende Handler was kaputtmachen\n");
  CRAEX_SET(lib1,is3) {
    /* Dieser Call setzt die gleiche Exception fuer sich selbst und
       hinterher hoffentlich wieder zurueck */
    printf("Ret: %d + %d = %d\n",1,1,lib1_driver(1,1));

    /* Dieser Call soll keinen Effect haben */
    printf("Ret: %d + %d = %d\n",1,1
	   ,doesnt_like_3(1) + doesnt_like_3or5(1));

    /* Dieser Call wuerde, wenn der vorige die Exception beschaedigt
       hat, zum top-level durchschlagen. Wenn alles OK ist, wird
       die exception hier gefangen */
    printf("Ret: %d + %d = %d\n",1,1
	   ,doesnt_like_3(3) + doesnt_like_3or5(3));
  }
  CRAEX_HANDLE {
    printf("Exception is3 gefangen\n");
  }
  CRAEX_END;

  printf("\nNoch durchlaufen, exception is5 nicht fangen\n");
  for (i = 1 ; i <=6 ; i++) {
    for (j = 1 ; j <=6 ; j++) {
      printf("Ret: %d + %d = %d\n",i,j,lib1_driver(i,j));
    }
  }

  return 0;
}
