#include <cra_ps.h>
#include <cra_ps_intern.h>

#ifdef HAVE_ASPRINTF

const char *const teststrings[] = {
  "(((",
  "foobar(lkadfj09 )  (0) (*)-0))",
  "foobar(lkadfj09 )(0) (*)-0))",
  NULL,
  "foobar|font=0|baz|font=2|foo",
  NULL
};

int main(int argc, char *argv[])
{
  const char *const *ss;
  struct psoptions pso;
  struct pstextopt psto;

  cra_c_debug = stdout;

  C_psoptions(&pso);
  C_pstextopt(&psto,&pso);

  ss = teststrings;
  while (*ss) {
    printf("'%s' -> '%s'\n",*ss,ps_expand(&psto,*ss));
    ss++;
  }
  return 0;
}
#else /* HAVE_VASPRINTF */
int main()
{
  system("if [ -d test ] ; then cd test ; fi ;"
	 "cat test_cra_ps.theory");
  return 0;
}
#endif /* HAVE_VASPRINTF */

