#include <stdio.h>
#include <stdlib.h>

#include <cra_sys.h>

static void testroutine(const char *const s, FILE *f)
{
  fprintf(f,"Does '%s' look right?\n",s);
}


int main(int argc, char *argv[])
{
  setbuf(stdout,NULL);

  cra_pifvalid(stdout,"is valid\n","foo",NULL);
  cra_pifvalid(stdout,"is valid","foo",testroutine);
  cra_pifvalid(stdout,(char *)0,"was not valid\n",NULL);
  cra_pifvalid(stdout,(char *)0,"was not valid",testroutine);
  cra_pifvalid(stdout,(char *)0,NULL,testroutine);
  cra_pifvalid(stdout,(char *)0,NULL,NULL);
  cra_pifvalid(stdout,(char *)0,(char *)0,NULL);

  /* See if old behaviour has been reverted */
  fprintf(stderr,"\n# Now expect a segmentation violation - intentionally\n");
  *((char *)0) = 0;

  exit(0);
}
